{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{# App Macros #}

{% macro display_list_position(list, page_size) %}
    {% set max = list.totalItemCount %}
    {% set end = page_size * list.currentPageNumber %}
    {% set start = end - page_size + 1 %}
    <p class="pull-left p-t-5 m-0">
        <span>Affichage <strong>{{ start }}</strong> à <strong>{{ end > max ? max : end }}</strong> de <strong>{{ max | number_format }}</strong> éléments</span>
    </p>
{% endmacro %}

{% macro flux_status_frame(status, label, description) %}
    <span class="_tooltip label label-flux status-{{ status }} " data-tooltip='{"side":"bottom"}' title="{{ description }}">
        <i class="fa fa-fw"></i> {{ label }}
    </span>
{% endmacro %}

{% macro rdf_resource_status_frame(status, label, description) %}
    <span class="_tooltip rdf-resource rdf-resource-status-{{ status }}" data-tooltip='{"side":"bottom"}' title="{{ description }}">
        {{ label }}
    </span>
{% endmacro %}

{% macro process_status_frame(status, label, description) %}
    {% import _self as appMacros %}
    {{ appMacros.flux_status_frame(status, label, description) }}
{% endmacro %}

{% macro process_mode_frame(mode, label, description) %}
    <span class="_tooltip" data-tooltip='{"side":"bottom"}' title="{{ description }}">
        <span class="process process-mode-{{ mode }}">
            <i class="fa"></i>&nbsp;&nbsp;{{ label }}
        </span>
    </span>
{% endmacro %}

{% macro percent_color(number, description) %}
    {% if number > 0 %}{% set display = {"class":"text-green","icon":"fa-caret-up"} %}{% endif %}
    {% if number < 0 %}{% set display = {"class":"text-red","icon":"fa-caret-down"} %}{% endif %}
    {% if number == 0 %}{% set display = {"class":"","icon":"fa-caret-right"} %}{% endif %}
    <span class="description-percentage m-l-10 _tooltip {{ display.class }}" data-tooltipster='{"side":"bottom"}' {% if description %}title="{{ description }}"{% endif %}>
        <i class="fa {{ display.icon }}"></i> {{ number | round | number_format(0, '.', ' ')  }}%
    </span>
{% endmacro %}

{% macro progress_bar(process, running) %}
    {% if process.statsProduceRDF %}
        {% set total = process.statsProduceRDF.total %}
        {% set progress = process.statsPersistRDF.total %}
    {% else %}
        {% set total = 100 %}
        {% set progress = 0 %}
    {% endif %}
    {% if running == 1 %}
        {% set total = 100 %}
        {% set progress = 1 %}
    {% endif %}
    {% set rate = total>0 ? (progress / total)*100:0 %}
    {% if rate >= 80 %}{% set class="progress-bar-success" %}{% endif %}
    {% if rate < 80 %}{% set class="progress-bar-warning" %}{% endif %}
    {% if rate == 0 %}{% set class="progress-bar-danger" %}{% endif %}
    {% if running == 1 %}{% set class="progress-bar-primary progress-bar-striped" %}{% endif %}
    <div class="progress no-margin _tooltip" data-tooltipster='{"side":"bottom"}' {% if running != 1 %}title="{{ progress }} / {{ total }}"{% endif %}>
        <div class="progress-bar {{ class }}" role="progressbar" aria-valuenow="{{ rate | number_format }}" aria-valuemin="0" aria-valuemax="100" style="width: {{ rate | number_format }}%">
            {% if running == 1 %}<i class="fa fa-refresh fa-spin fa-fw"></i>{% endif %}
            <span>{{ rate | number_format }}%</span>
        </div>
    </div>
{% endmacro %}

{% macro help(text, side) %}
    <span class="fa fa-question-circle-o text-muted _tooltip" data-tooltip title="{{ text }}"></span>
{% endmacro %}

{% macro process_mode_icon(process) %}
    <span class="fa {% spaceless %}
        {% if process.mode == constant('AppBundle\\Entity\\Flux::MODE_PULL') %}fa-download {% endif %}
        {% if process.mode == constant('AppBundle\\Entity\\Flux::MODE_PUSH') %}fa-upload {% endif %}
        {% if process.mode == constant('AppBundle\\Entity\\Flux::MODE_MANUAL') %}fa-hand-o-up {% endif %}
    {% endspaceless %}">
    </span> {{ (get_static('AppBundle\\Entity\\Flux','modeDefinitions'))[process.mode][0] }}
{% endmacro %}

{% macro role_label(role) %}
    {% if 'ADMIN' in role %}
        <i class="fa fa-user-secret"></i>
    {% endif %}
    {{ {
        ROLE_SUPER_ADMIN: "Super administrateur",
        ROLE_ADMIN: "Administrateur",
        ROLE_USER: "Producteur"
    }[role] }}
{% endmacro %}

{# conversions #}
{% macro bytesToSize(bytes) %}
    {% spaceless %}
    {% set kilobyte = 1024 %}
    {% set megabyte = kilobyte * 1024 %}
    {% set gigabyte = megabyte * 1024 %}
    {% set terabyte = gigabyte * 1024 %}

    {% if bytes < kilobyte %}
    {{ bytes ~ 'o' }}
    {% elseif bytes < megabyte %}
    {{ (bytes / kilobyte)|round|number_format(0, '.') ~ 'ko' }}
    {% elseif bytes < gigabyte %}
    {{ (bytes / megabyte)|number_format(2, '.') ~ 'Mo' }}
    {% elseif bytes < terabyte %}
    {{ (bytes / gigabyte)|number_format(2, '.') ~ 'Go' }}
    {% else %}
    {{ (bytes / terabyte)|number_format(2, '.') ~ 'To' }}
    {% endif %}
    {% endspaceless %}
{% endmacro %}